/* Exercise 7.  

Define a class called Histogram that keeps count of numbers in some intervals 
specified as arguments to Histogram's constructor. Provide functions to print
out the Histogram */



#include<iostream.h>
#include<fstream.h>

class Histogram
{
public:
    Histogram (float _loVal, float _hiVal, int _numBins);
    ~Histogram() {}

    void add(float val);

    void view();

private:
    int* myHistogram;

    float loVal, hiVal;
    int numBins;

    float w;  // width of bin
};

Histogram::Histogram (float _loVal, float _hiVal, int _numBins) {
    loVal   = _loVal;
    hiVal   = _hiVal;
    numBins = _numBins;

    w = (hiVal - loVal) / numBins;

    myHistogram = new int [numBins];
    for(int i = 0; i < numBins; i++) {
        myHistogram [i] = 0;
    }
}


void Histogram :: add(float val) {
    if(val < loVal) {
	cout << "Warning: val " << val << " is too low\n" ;
    } else if (val > hiVal) {
	cout << "Warning: val " << val << " is too high\n" ;
    } else if (val == hiVal) {
        myHistogram [numBins]++;
    } else {
	for(int i = 0; i < numBins; i++) {
 
	    if((loVal + i * w) <= val && val < (loVal + (i + 1) * w)) {
		// val belongs in i'th bin

		myHistogram [i]++;
	    }
	} 
    }
}

void Histogram ::view() {
    cout << "\n";

    int maxBin = 0;
    for(int i = 0; i < numBins; i++) {
	if(myHistogram [i] > maxBin)
            maxBin = myHistogram [i];
    }

    for(int n = maxBin ; n > 0 ; n--) {
        for(int i = 0; i < numBins; i++)
            if(myHistogram [i] >= n)
	        cout << "    X";
            else
	        cout << "     ";
	cout << "\n";
    }

    cout << "\n";
    for(int i = 0; i < numBins; i++) {
	cout << "    " << i ;
    }
    cout << "\n";
}

int main()
{
	float loVal, hiVal;
        int numBins;
        char filename [100];
	
	cout << "Please enter lowest value: ";
	cin >> loVal;
	cout << "Please enter highest value: ";
	cin >> hiVal;
	cout << "\nPlese select number of bins: ";
	cin >> numBins;

	cout << "\nPlese select file to get data from: ";
	cin >> filename ;
	
        ifstream dataStream(filename);

	Histogram counter(loVal, hiVal, numBins);

        float val ;
        while(dataStream >> val)
          counter.add(val);

        counter.view();
        
	return 0;
}
